zero_length_keys.sh 4.0 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128
  1. #!/bin/sh
  2. # Check that tor regenerates keys when key files are zero-length
  3. # Test for bug #13111 - Tor fails to start if onion keys are zero length
  4. #
  5. # Usage:
  6. # ./zero_length_keys.sh
  7. # Run all the tests below
  8. # ./zero_length_keys.sh -z
  9. # Check tor will launch and regenerate zero-length keys
  10. # ./zero_length_keys.sh -d
  11. # Check tor regenerates deleted keys (existing behaviour)
  12. # ./zero_length_keys.sh -e
  13. # Check tor does not overwrite existing keys (existing behaviour)
  14. #
  15. # Exit Statuses:
  16. # 0: test succeeded - tor regenerated/kept the files
  17. # 1: test failed - tor did not regenerate/keep the files
  18. # 2: test failed - tor did not generate the key files on first run
  19. # 3: a command failed - the test could not be completed
  20. #
  21. if [ $# -lt 1 ]; then
  22. echo "Testing that tor correctly handles zero-length keys"
  23. "$0" -z && "$0" -d && "$0" -e
  24. exit $?
  25. fi
  26. DATA_DIR=`mktemp -d -t tor_zero_length_keys.XXXXXX`
  27. if [ -z "$DATA_DIR" ]; then
  28. echo "Failure: mktemp invocation returned empty string" >&2
  29. exit 3
  30. fi
  31. if [ ! -d "$DATA_DIR" ]; then
  32. echo "Failure: mktemp invocation result doesn't point to directory" >&2
  33. exit 3
  34. fi
  35. trap "rm -rf '$DATA_DIR'" 0
  36. # DisableNetwork means that the ORPort won't actually be opened.
  37. # 'ExitRelay 0' suppresses a warning.
  38. TOR="./src/or/tor --hush --DisableNetwork 1 --ShutdownWaitLength 0 --ORPort 12345 --ExitRelay 0"
  39. if [ -s "$DATA_DIR"/keys/secret_id_key ] && [ -s "$DATA_DIR"/keys/secret_onion_key ] &&
  40. [ -s "$DATA_DIR"/keys/secret_onion_key_ntor ]; then
  41. echo "Failure: Previous tor keys present in tor data directory" >&2
  42. exit 3
  43. else
  44. echo "Generating initial tor keys"
  45. $TOR --DataDirectory "$DATA_DIR" --PidFile "$DATA_DIR"/pid &
  46. TOR_PID=$!
  47. # generate SIGTERM, hopefully after the keys have been regenerated
  48. sleep 5
  49. kill $TOR_PID
  50. wait $TOR_PID
  51. # tor must successfully generate non-zero-length key files
  52. if [ -s "$DATA_DIR"/keys/secret_id_key ] && [ -s "$DATA_DIR"/keys/secret_onion_key ] &&
  53. [ -s "$DATA_DIR"/keys/secret_onion_key_ntor ]; then
  54. true #echo "tor generated the initial key files"
  55. else
  56. echo "Failure: tor failed to generate the initial key files"
  57. exit 2
  58. fi
  59. fi
  60. #ls -lh "$DATA_DIR"/keys/ || exit 3
  61. # backup and keep/delete/create zero-length files for the keys
  62. FILE_DESC="keeps existing"
  63. # make a backup
  64. cp -r "$DATA_DIR"/keys "$DATA_DIR"/keys.old
  65. # delete keys for -d or -z
  66. if [ "$1" != "-e" ]; then
  67. FILE_DESC="regenerates deleted"
  68. rm "$DATA_DIR"/keys/secret_id_key || exit 3
  69. rm "$DATA_DIR"/keys/secret_onion_key || exit 3
  70. rm "$DATA_DIR"/keys/secret_onion_key_ntor || exit 3
  71. fi
  72. # create empty files for -z
  73. if [ "$1" = "-z" ]; then
  74. FILE_DESC="regenerates zero-length"
  75. touch "$DATA_DIR"/keys/secret_id_key || exit 3
  76. touch "$DATA_DIR"/keys/secret_onion_key || exit 3
  77. touch "$DATA_DIR"/keys/secret_onion_key_ntor || exit 3
  78. fi
  79. echo "Running tor again to check if it $FILE_DESC keys"
  80. $TOR --DataDirectory "$DATA_DIR" --PidFile "$DATA_DIR"/pid &
  81. TOR_PID=$!
  82. # generate SIGTERM, hopefully after the keys have been regenerated
  83. sleep 5
  84. kill $TOR_PID
  85. wait $TOR_PID
  86. #ls -lh "$DATA_DIR"/keys/ || exit 3
  87. # tor must always have non-zero-length key files
  88. if [ -s "$DATA_DIR"/keys/secret_id_key ] && [ -s "$DATA_DIR"/keys/secret_onion_key ] &&
  89. [ -s "$DATA_DIR"/keys/secret_onion_key_ntor ]; then
  90. # check if the keys are different to the old ones
  91. diff -q -r "$DATA_DIR"/keys "$DATA_DIR"/keys.old > /dev/null
  92. SAME_KEYS=$?
  93. # if we're not testing existing keys,
  94. # the current keys should be different to the old ones
  95. if [ "$1" != "-e" ]; then
  96. if [ $SAME_KEYS -ne 0 ]; then
  97. echo "Success: test that tor $FILE_DESC key files: different keys"
  98. exit 0
  99. else
  100. echo "Failure: test that tor $FILE_DESC key files: same keys"
  101. exit 1
  102. fi
  103. else #[ "$1" == "-e" ]; then
  104. if [ $SAME_KEYS -eq 0 ]; then
  105. echo "Success: test that tor $FILE_DESC key files: same keys"
  106. exit 0
  107. else
  108. echo "Failure: test that tor $FILE_DESC key files: different keys"
  109. exit 1
  110. fi
  111. fi
  112. else
  113. echo "Failure: test that tor $FILE_DESC key files: no key files"
  114. exit 1
  115. fi